package com.altinity.opsview.odw.model;

/**
 * Copyright (C) 2008 Opsera Limited. All rights reserved
 *
 * This file is part of Opsview
 * 
 * Opsview is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * Opsview is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Opsview; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 * 
 */

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class ReportWeek {

	private String weekOfYear = "";

	private String year = "";

	private Date reportStartDate = null;

	private Date reportEndDate = null;

	Calendar cal = null;

	SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

	private Date weekStartDate =null;

	private Date weekEndDate =null;

	/**
	 * 
	 */
	public ReportWeek(String year, String weekOfYear,  Date reportStartDate, Date reportEndDate) {
		
		this.year = year;
		this.weekOfYear = weekOfYear;
		this.reportStartDate = reportStartDate;
		this.reportEndDate = reportEndDate;
		
		cal = Calendar.getInstance();
		cal.setMinimalDaysInFirstWeek(4);
		cal.setFirstDayOfWeek(Calendar.MONDAY);
		cal.set(Calendar.YEAR, Integer.parseInt(year));
		cal.set(Calendar.WEEK_OF_YEAR, Integer.parseInt(weekOfYear));
		cal.set(Calendar.DAY_OF_WEEK, Calendar.MONDAY);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE,0);
		cal.set(Calendar.SECOND,0);
		cal.set(Calendar.MILLISECOND,0);
		
		this.weekStartDate = cal.getTime();
		
		this.weekEndDate = new Date(weekStartDate.getTime()+(7 *24 * 60 *60 *1000)-1000);
	}

	/**
	 * 
	 */
	public Date getReportWeekStartDate() {
		
		Date startDate;
		cal = Calendar.getInstance();
		cal.setMinimalDaysInFirstWeek(4);
		cal.setFirstDayOfWeek(Calendar.MONDAY);
		cal.set(Calendar.YEAR, Integer.parseInt(year));
		cal.set(Calendar.WEEK_OF_YEAR, Integer.parseInt(weekOfYear));
		cal.set(Calendar.DAY_OF_WEEK, Calendar.MONDAY);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE,0);
		cal.set(Calendar.SECOND,0);
		cal.set(Calendar.MILLISECOND,0);
		
		if (cal.getTime().before(reportStartDate))
			startDate = reportStartDate;
		else
			startDate = cal.getTime();
		
		return startDate;
	}

	/**
	 * 
	 */
	public Date getReportWeekEndDate() {
		
		Date endDate;
		cal = Calendar.getInstance();
		cal.setMinimalDaysInFirstWeek(4);
		cal.setFirstDayOfWeek(Calendar.MONDAY);
		cal.set(Calendar.YEAR, Integer.parseInt(year));
		cal.set(Calendar.WEEK_OF_YEAR, Integer.parseInt(weekOfYear));
		cal.set(Calendar.DAY_OF_WEEK, Calendar.SUNDAY);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE,0);
		cal.set(Calendar.SECOND,0);
		cal.set(Calendar.MILLISECOND,0);
		if (cal.getTime().after(reportEndDate))
			endDate = reportEndDate;
		else
			endDate = cal.getTime();
		return endDate;
	}

	/**
	 * 
	 */
	public String getWeekOfYear() {
		
		return weekOfYear;
	}

	/**
	 * 
	 */
	public void setWeekOfYear(String weekOfYear) {
		
		this.weekOfYear = weekOfYear;
	}

	/**
	 * 
	 */
	public boolean isLastWeekInReport() {
		
		if (weekEndDate.equals(reportEndDate) || weekEndDate.after(reportEndDate))
			return true;
		else
			return false;
	}

	/**
	 * 
	 */
	public Date getWeekStartDate() {
		
		return weekStartDate;
	}
}
