package com.excira.reports;

/**
 * Copyright (C) 2008 Opsera Limited. All rights reserved
 *
 * This file is part of Opsview
 * 
 * Opsview is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * Opsview is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Opsview; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 * 
 */

import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Templates;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.sax.SAXResult;
import javax.xml.transform.stream.StreamSource;

import org.apache.fop.apps.Fop;
import org.apache.fop.apps.FopFactory;
import org.apache.fop.apps.MimeConstants;
import org.apache.log4j.Logger;
import org.dom4j.Document;
import org.dom4j.io.DocumentSource;
import org.dom4j.io.OutputFormat;
import org.dom4j.io.XMLWriter;

public class ReportEngine {

	/**
	 * 
	 */
	public static void main(String[] args) {

		System.out.println("ReportEngine - Start");

		try {

			// String key = "javax.xml.transform.TransformerFactory";
			// String value =
			// "org.apache.xalan.xsltc.trax.TransformerFactoryImpl";
			// Properties props = System.getProperties();
			// props.put(key, value);
			// System.setProperties(props);

			// //
			// File xml = new File("C:\\eclipse3.2\\workspace\\Excira Reporting
			// Engine\\XML\\class4.xml");
			// SAXReader reader = new SAXReader();
			// Document doc = reader.read(xml);
			//
			// // Transfomers! More than meets the eye!
			// ReportEngine re = new ReportEngine();
			//		
			// re.generateFOFile(doc,
			// // "C:\\eclipse3.2\\workspace\\Excira Reporting
			// // Engine\\XSL\\ISRReportHTMLInternal.xsl");
			// "C:\\eclipse3.2\\workspace\\Excira Reporting
			// Engine\\XSL\\ISRReportFoInternal.xsl");
			//			
			// re.convertFO2PDF();
		} catch (Exception e) {
			System.out.println("Error in ReportEngine");
			e.printStackTrace();
		}

		System.out.println("ReportEngine - End");
	}

	public void genratePDF(Document doc, String xsltFilePath, String pdfFilePath) throws Exception {
		
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		OutputFormat format = OutputFormat.createPrettyPrint(); // Currently strips CR/LF 
		XMLWriter writer = new XMLWriter(baos, format);
		writer.write( doc );
		writer.close();

		Logger.getRootLogger().debug("Report XML\n" + baos.toString());

		// Step 1: Construct a FopFactory
		// (reuse if you plan to render multiple documents!)
		FopFactory fopFactory = FopFactory.newInstance();

		// Step 2: Set up output stream.
		// Note: Using BufferedOutputStream for performance reasons (helpful
		// with FileOutputStreams).
		OutputStream out = new BufferedOutputStream(new FileOutputStream(new File(pdfFilePath)));

		try {
			// Step 3: Construct fop with desired output format
			Fop fop = fopFactory.newFop(MimeConstants.MIME_PDF, out);

			// Step 4: Setup JAXP using identity transformer
			Transformer transformer = getTransformer(xsltFilePath);

			// Step 5: Setup input and output for XSLT transformation
			// Setup input stream
			Source src = new DocumentSource(doc);

			// Resulting SAX events (the generated FO) must be piped through to
			// FOP
			Result res = new SAXResult(fop.getDefaultHandler());

			// Step 6: Start XSLT transformation and FOP processing
			transformer.transform(src, res);

		} finally {
			// Clean-up
			out.close();
		}

	}

	/**
	 * 
	 */
	private Transformer getTransformer(String xslFilePath) throws TransformerConfigurationException {

		TransformerFactory factory = TransformerFactory.newInstance();
		Templates templates = factory.newTemplates(new StreamSource(xslFilePath));
		return templates.newTransformer();
	}

}
