<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE foo [
	<!ENTITY nbsp "&#160;">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">
	<xsl:attribute-set name="ed">
		<xsl:attribute name="border">0.5pt solid black</xsl:attribute>
		<xsl:attribute name="font-size">8pt</xsl:attribute>
		<xsl:attribute name="padding">6pt</xsl:attribute>
		
	</xsl:attribute-set>
	
	<xsl:attribute-set name="keyTable">
		<xsl:attribute name="border-bottom">1pt solid white</xsl:attribute>		
		<xsl:attribute name="border-left">1pt solid white</xsl:attribute>
		<xsl:attribute name="border-right">1pt solid white</xsl:attribute>	
		<xsl:attribute name="font-size">8pt</xsl:attribute>
		<xsl:attribute name="padding">10pt 0 0 0</xsl:attribute>
	</xsl:attribute-set>		
	
	<xsl:attribute-set name="keyText">
		<xsl:attribute name="font-size">8pt</xsl:attribute>
		<xsl:attribute name="font-weight">bold</xsl:attribute>
	</xsl:attribute-set>	

	<!-- *************************************************************************************************
	Exception Detail
	*************************************************************************************************** -->
	<xsl:template name="exception-detail" match="element[@name='exception-detail']">
		<fo:block break-before="page"/>
		<xsl:call-template name="element-title"/>
			<xsl:choose>
			<xsl:when test="empty">
				<fo:block >No exceptions in reporting period.</fo:block>
			</xsl:when>
			<xsl:otherwise>	
				<fo:block space-after="10pt">
					<fo:table table-layout="fixed"  border-width="1pt" border-color="#999999" border-style="solid">
						<fo:table-column column-width="5cm"/>
						<xsl:for-each select="weeks/week">
							<fo:table-column column-width="2cm"/>
						</xsl:for-each>
						<fo:table-header>
			  				<fo:table-row>
								<fo:table-cell xsl:use-attribute-sets="ed"><fo:block font-weight="bold">Hostgroup Name</fo:block></fo:table-cell>
			    				<xsl:for-each select="weeks/week">
									<fo:table-cell xsl:use-attribute-sets="ed" padding="6pt">
										<fo:block font-weight="bold" text-align="center">Week <xsl:value-of select="weekno"/></fo:block>
										<fo:block font-weight="bold" text-align="center"><xsl:value-of select="startdate"/> </fo:block>
										<fo:block font-weight="bold" text-align="center"> <xsl:value-of select="enddate"/></fo:block>
									</fo:table-cell>
								</xsl:for-each>
			  				</fo:table-row>
						</fo:table-header>						
						<fo:table-body>	
							<xsl:for-each select="hostgroups/hostgroup">
								<fo:table-row>
									<fo:table-cell xsl:use-attribute-sets="ed"><fo:block font-weight="bold"><xsl:value-of select="name"/></fo:block></fo:table-cell>
									<xsl:for-each select="availability/week">
										<fo:table-cell xsl:use-attribute-sets="ed" padding="0">
											<fo:block>
												<xsl:choose>
													<xsl:when test="empty">
														<fo:block text-align="center" padding="6pt">
															No Data
														</fo:block>													
													</xsl:when>
													<xsl:otherwise>
														<fo:table>
				 											<xsl:attribute name="color">
				   												<xsl:value-of select="@color" />
				  											</xsl:attribute> 
															<fo:table-column column-width="1cm"/>
															<fo:table-column column-width="1cm"/>
															<fo:table-body>	
																<fo:table-row>
																	<fo:table-cell xsl:use-attribute-sets="ed" number-columns-spanned="2">
																		<fo:block text-align="center">
																			<xsl:value-of select="availability"/>
																		</fo:block>
																	</fo:table-cell>
																</fo:table-row>
																<fo:table-row>
																	<fo:table-cell xsl:use-attribute-sets="ed">
																		<fo:block text-align="center">
																				<xsl:value-of select="scheduled-downtime"/>
																		</fo:block></fo:table-cell>
																	<fo:table-cell xsl:use-attribute-sets="ed">
																		<fo:block text-align="center" >
																			<xsl:value-of select="unscheduled-downtime"/>
																		</fo:block>
																	</fo:table-cell>
																</fo:table-row>
															</fo:table-body>
														</fo:table>
													</xsl:otherwise>
												</xsl:choose>
											</fo:block>
										</fo:table-cell>
									</xsl:for-each>
								</fo:table-row>
							</xsl:for-each>
						</fo:table-body>		
					</fo:table>
				</fo:block>
				<fo:block space-after="10pt">
					<fo:table>
						<fo:table-column column-width="2.5cm"/>
						<fo:table-column column-width="2.5cm"/>
						<fo:table-body>	
							<fo:table-row>
								<fo:table-cell xsl:use-attribute-sets="keyText" number-columns-spanned="2">
									<fo:block text-align="left">
										Key
									</fo:block>
								</fo:table-cell>
							</fo:table-row>									
							<fo:table-row>
								<fo:table-cell xsl:use-attribute-sets="ed" number-columns-spanned="2">
									<fo:block text-align="center">
										Availability %
									</fo:block>
								</fo:table-cell>
							</fo:table-row>
							<fo:table-row>
								<fo:table-cell xsl:use-attribute-sets="ed">
									<fo:block text-align="center">
											Scheduled Downtime %
									</fo:block>
								</fo:table-cell>
								<fo:table-cell xsl:use-attribute-sets="ed">
									<fo:block text-align="center" >
										Unscheduled Downtime %
									</fo:block>
								</fo:table-cell>
							</fo:table-row>										
						</fo:table-body>
					</fo:table>
				</fo:block>
				<fo:block font-size="8pt" text-align="left">
					<fo:inline background-color="#ffd200">&nbsp;&nbsp;&nbsp;</fo:inline>&nbsp;&nbsp;Yellow text means the availability % is below the first availability threshold.
				</fo:block>
				<fo:block font-size="8pt" text-align="left">
					<fo:inline background-color="red">&nbsp;&nbsp;&nbsp;</fo:inline>&nbsp;&nbsp;Red text means the availability % is below the second availability threshold.
				</fo:block>	
				
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
